[4mDACS.SERVICES[24m(8)           DACS Web Services Manual           [4mDACS.SERVICES[24m(8)

[1mNAME dacs.services - DACS [22mweb services

[1mSYNOPSIS[0m

       [4mdacswebservice[24m [[34m[1mdacsoptions[0m[1m[22m[1]]

[1mDESCRIPTION[0m

       These web services are part of the [1mDACS [22msuite.

       The following is a list of [1mDACS [22mweb services with a brief description
       of each. General aspects of [1mDACS [22mand its web services are discussed in
       [34m[1mdacs(1)[0m[1m[22m[2]. Individual web services are discussed in more detail
       elsewhere. By default, these CGI programs are installed in the dacs
       subdirectory of the [1mApache [22mcgi-bin directory.

       By convention, [1mDACS [22mweb service names use underscores as word
       separators. Some web services have command counterparts; their names
       omit the underscores.

       •

               [1mdacs_admin[0m
               A low-level administration tool for [1mDACS[22m.
               [[34m[1mdacs_admin(8)[0m[1m[22m[3]]


       •

               [1mdacs_auth_agent[0m
               Authenticate by delegating responsibility to a trusted identity.
               [[34m[1mdacs_auth_agent(8)[0m[1m[22m[4]]


       •

               [1mdacs_auth_transfer[0m
               Transfer credentials between federations.
               [[34m[1mdacs_auth_transfer(8)[0m[1m[22m[5]]


       •

               [1mdacs_authenticate[0m
               The [1mDACS [22mauthentication service.
               [[34m[1mdacs_authenticate(8)[0m[1m[22m[6]]


       •

               [1mdacs_conf[0m
               Process and display [1mDACS [22mconfiguration files.
               [[34m[1mdacs_conf(8)[0m[1m[22m[7]]


       •

               [1mdacs_current_credentials[0m
               Display elements of each set of credentials sent with the request.
               [[34m[1mdacs_current_credentials(8)[0m[1m[22m[8]]


       •

               [1mdacs_error[0m
               Simple error handler.
               [[34m[1mdacs_error(8)[0m[1m[22m[9]]


       •

               [1mdacs_group[0m
               A [1mDACS [22mgroup administration tool.
               [[34m[1mdacs.groups(5)[0m[1m[22m[10]]


       •

               [1mdacs_list_jurisdictions[0m
               Display information about all jurisdictions in a federation.
               [[34m[1mdacs_list_jurisdictions(8)[0m[1m[22m[11]]


       •

               [1mdacs_notices[0m
               Notice presentation and acknowledgement handler.
               [[34m[1mdacs_notices(8)[0m[1m[22m[12]]


       •

               [1mdacs_passwd[0m
               Administration tool for passwords used by [1mlocal_passwd_authenticate[22m.
               [[34m[1mdacs_passwd(8)[0m[1m[22m[13]]


       •

               [1mdacs_prenv[0m
               Display environment variables.
               [[34m[1mdacs_prenv(8)[0m[1m[22m[14]]


       •

               [1mdacs_select_credentials[0m
               Temporarily disable credentials.
               [[34m[1mdacs_select_credentials(8)[0m[1m[22m[15]]


       •

               [1mdacs_signout[0m
               Typically called from a browser, this web services causes one or more
               cookies (each representing a [1mDACS [22midentity) to be deleted.
               Cookies are automatically deleted when a browser terminates, but it
               is sometimes useful to explicitly logoff.
               [[34m[1mdacs_signout(8)[0m[1m[22m[16]]


       •

               [1mdacs_version[0m
               Display version information.
               [[34m[1mdacs_version(8)[0m[1m[22m[17]]


       •

               [1mdacs_token[0m
               Manage one-time password token accounts.
               [[34m[1mdacs_token(8)[0m[1m[22m[18]]


       •

               [1mdacs_transform[0m
               Rule-based document transformation.
               [[34m[1mdacs_transform(8)[0m[1m[22m[19]]


       •

               [1mdacs_uproxy[0m
               Minimal HTTP proxying.
               [[34m[1mdacs_uproxy(8)[0m[1m[22m[20]]


       •

               [1mdacs_vfs[0m
               Manage items in the [1mDACS [22mvirtual filestore.
               [[34m[1mdacs_vfs(8)[0m[1m[22m[21]]


       •

               [1mlocal_*_authenticate[0m
               Authentication modules used by [34m[1mdacs_authenticate(8)[0m[1m[22m[6].
               Each one implements a particular authentication method and optionally
               returns role information.


       •

               [1mlocal_*_roles[0m
               Roles modules used by [34m[1mdacs_authenticate(8)[0m[1m[22m[6].


       •

               [1mdacs_infocard[22m, [1mdacs_managed_infocard[22m, [1mdacs_mex[22m, [1mdacs_sts[0m
               InfoCard support.
               [[34m[1mdacs_infocard(8)[0m[1m[22m[22], [34m[1mdacs_managed_infocard(8)[0m[1m[22m[23], [34m[1mdacs_mex(8)[0m[1m[22m[24], [34m[1mdacs_sts(8)[0m[1m[22m[25]]


   [1mStandard CGI Arguments for DACS Web Services[0m

       The following set of CGI arguments are recognized by most [1mDACS [22mweb
       services. When the document for a [1mDACS [22mweb service says that it accepts
       "the standard CGI arguments", it is referring to the following
       arguments; not all of these arguments are necessarily meaningful to all
       web services, however.

       In general, duplicate CGI argument names are not allowed; i.e., you
       cannot pass an argument named [4mDACS_JURISDICTION[24m more than once when
       calling a [1mDACS [22mweb service, even if each occurrence of the argument has
       the same value.

       [4mDACS_JURISDICTION[0m
           This argument is required by most web services. It specifies the
           name of the jurisdiction to which the request is being sent. Web
           services will verify that the jurisdiction that receives the
           request is the same as the intended recipient.

       [4mDACS_VERSION[0m
           If this argument is present, it specifies the major [1mDACS [22mversion
           number (e.g., 1.5) expected by the client. The service request will
           fail if the [1mDACS [22msoftware does not support this version number. If
           not provided, no compatibility checks are performed.

       FILE
           Reserved for future use for file uploading. Requests content type
           application/x-dacs-credentials.

       [4mFORMAT[0m
           This optional argument requests a particular output format. The
           default value varies, but it is usually HTML. Not all formats are
           supported by every web service; refer to the manual page for
           details. The following values may be recognized:

           HTML
               Requests content type text/html;

           JSON
               Requests content type application/json ([4mJavaScript[24m [4mObject[0m
               [4mNotation[24m, see [34m[1mwww.json.org[0m[1m[22m[26], [34m[1mECMA-404[0m[1m[22m[27], [34m[1mRFC 4627[0m[1m[22m[28], and
               [34m[1mRFC 7159[0m[1m[22m[29]);

           PHP
               Used by the [34m[1mdacs_list_jurisdictions(8)[0m[1m[22m[11] web service when its
               output is to processed by PHP;

           PLAIN
               Requests content type text/plain;

           TEXT
               Like PLAIN except that no content type is specified;

           URI
               An encoding based on [34m[1mRFC 2396[0m[1m[22m[30];

           URL
               Equivalent to URI;

           XML
               Requests content type text/xml. If the DTD_BASE_URL directive
               is configured, a DOCTYPE element with the keyword SYSTEM
               followed by a value derived from DTD_BASE_URL is emitted; e.g.,



                   <!DOCTYPE foo SYSTEM "http://fedroot.com/dacs/dtd-xsd/foo.dtd">

               If DTD_BASE_URL is not configured, an internal DTD is emitted.
               A default xmlns attribute is emitted in both cases;

           XMLDTD
               Requests content type text/xml This emits an internal DTD and
               default xmlns attribute;

           XMLSCHEMA
               Requests content type text/xml. If the XSD_BASE_URL directive
               is configured, xmlns:xsi and xsi:schemaLocation attributes are
               emitted, the former having a compile-time value (e.g.,
               "https://www.w3.org/2001/XMLSchema-instance") and the latter
               being a pair, the first having the same value as the value of
               the xmlns attribute and the second having a value derived from
               XSD_BASE_URL; e.g.,



                   <foo xmlns="http://fedroot.com/dacs/v1.5"
                       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                       xsi:schemaLocation="http://fedroot.com/dacs/v1.5
                       http://amd.dss.bc.ca/dacs/dtd-xsd/foo.xsd">


               The default xmlns attribute is also emitted. If XSD_BASE_URL is
               not configured, only the default xmlns attribute is emitted;
               and

           XMLSIMPLE
               Requests content type text/xml Neither a DTD (no DOCTYPE) nor a
               default xmlns attribute is emitted.

           Also see the [34m[1m-format[0m[1m[22m[31] command line flag (one of the
           [34m[4mdacsoptions[0m[4m[24m[1]).

[1mDIAGNOSTICS[0m

       Programs usually exit 0 if everything was fine, 1 if an error occurred.

[1mAUTHOR[0m

       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[32])

[1mCOPYING[0m

       Copyright © 2003-2025 Distributed Systems Software. See the [34m[1mLICENSE[0m[1m[22m[33]
       file that accompanies the distribution for licensing information.




[1mNOTES[0m

        1.
           dacsoptions
           http://dacs.dss.ca/man/dacs.1.html#dacsoptions

        2. dacs(1)
           http://dacs.dss.ca/man/dacs.1.html

        3. dacs_admin(8)
           http://dacs.dss.ca/man/dacs_admin.8.html

        4. dacs_auth_agent(8)
           http://dacs.dss.ca/man/dacs_auth_agent.8.html

        5. dacs_auth_transfer(8)
           http://dacs.dss.ca/man/dacs_auth_transfer.8.html

        6. dacs_authenticate(8)
           http://dacs.dss.ca/man/dacs_authenticate.8.html

        7. dacs_conf(8)
           http://dacs.dss.ca/man/dacs_conf.8.html

        8. dacs_current_credentials(8)
           http://dacs.dss.ca/man/dacs_current_credentials.8.html

        9. dacs_error(8)
           http://dacs.dss.ca/man/dacs_error.8.html

       10. dacs.groups(5)
           http://dacs.dss.ca/man/dacs.groups.5.html

       11. dacs_list_jurisdictions(8)
           http://dacs.dss.ca/man/dacs_list_jurisdictions.8.html

       12. dacs_notices(8)
           http://dacs.dss.ca/man/dacs_notices.8.html

       13. dacs_passwd(8)
           http://dacs.dss.ca/man/dacs_passwd.8.html

       14. dacs_prenv(8)
           http://dacs.dss.ca/man/dacs_prenv.8.html

       15. dacs_select_credentials(8)
           http://dacs.dss.ca/man/dacs_select_credentials.8.html

       16. dacs_signout(8)
           http://dacs.dss.ca/man/dacs_signout.8.html

       17. dacs_version(8)
           http://dacs.dss.ca/man/dacs_version.8.html

       18. dacs_token(8)
           http://dacs.dss.ca/man/dacs_token.8.html

       19. dacs_transform(8)
           http://dacs.dss.ca/man/dacs_transform.8.html

       20. dacs_uproxy(8)
           http://dacs.dss.ca/man/dacs_uproxy.8.html

       21. dacs_vfs(8)
           http://dacs.dss.ca/man/dacs_vfs.8.html

       22. dacs_infocard(8)
           http://dacs.dss.ca/man/dacs_infocard.8.html

       23. dacs_managed_infocard(8)
           http://dacs.dss.ca/man/dacs_managed_infocard.8.html

       24. dacs_mex(8)
           http://dacs.dss.ca/man/dacs_mex.8.html

       25. dacs_sts(8)
           http://dacs.dss.ca/man/dacs_sts.8.html

       26. www.json.org
           https://www.json.org

       27. ECMA‐404
           https://www.ecma‐international.org/publications/files/ECMA‐ST/ECMA‐404.pdf

       28. RFC 4627
           https://www.rfc‐editor.org/rfc/rfc4627.txt

       29. RFC 7159
           https://www.rfc‐editor.org/rfc/rfc7159.txt

       30. RFC 2396
           https://www.rfc‐editor.org/rfc/rfc2396.txt

       31. [1m‐format[0m
           http://dacs.dss.ca/man/dacs.1.html#format‐arg

       32. www.dss.ca
           https://www.dss.ca

       33. LICENSE
           http://dacs.dss.ca/man/../misc/LICENSE

DACS 1.5.0                        04/09/2025                  [4mDACS.SERVICES[24m(8)
